

#include <stdio.h>
#include <iostream.h>
#include <windows.h>
#include "SWI-Prolog.h"
#include <ole2.h>

#define CCONV _stdcall
#define NOMANGLE

int count_atoms();
int consult(char*);
void ancestor();
void ancestor1(const char *me);
void close_query();

term_t      current_arguments = 0;
predicate_t current_predicate = 0;
qid_t       current_query = 0;
fid_t       current_frame = 0;

/* ************************************************************************* */
/*	                    Main                                                 */
/* ************************************************************************* */

int
startProlog()
{ 
	char *argv[1];

	// strcpy(argv[0],"pl_interface.exe");
	if ( !PL_initialise(1, argv) )  {
	MessageBox(NULL, "Wrong", "Does not start", MB_OK|MB_TASKMODAL);
		PL_halt(1);	
		return 0;
	}
	else {
		return 1;
	}
			
}

 
int 
consult(char *file)
{ 
	term_t a0 = PL_new_term_ref();
    predicate_t p;
	qid_t query;

	p = PL_predicate("consult", 1, "user");

	PL_put_atom_chars(a0, file);
	query = PL_open_query(NULL, PL_Q_NORMAL, p, a0);
	return(PL_next_solution(query));
}

/* Deze functie is overgenomen uit de Prolog manual.
   NB: er staat daar een foutje in:
   PL_call(t, NULL) -> PL_call(goal, NULL)
*/

int
countAtoms()
{ // fid_t fid = PL_open_foreign_frame();
  term_t goal  = PL_new_term_ref(); /* query: statistics(atoms, Y) */
  term_t a1    = PL_new_term_ref(); /* argument constante "atoms" */
  term_t a2    = PL_new_term_ref(); /* variabele */
  functor_t s2 = PL_new_functor(PL_new_atom("statistics"), 2); /* statistics(X,Y) */

  int atoms;

  PL_put_atom_chars(a1, "atoms"); /* X = atoms */
  PL_cons_functor(goal, s2, a1, a2);  /* function -> goal */ 
  PL_call(goal, NULL);         /* call it in current module */

  PL_get_integer(a2, &atoms);
  // PL_discard_foreign_frame(fid);

  return atoms;
}


/* overgenomen uit Prolog manual */

void testanchestor()
{ 
	term_t a1 = PL_new_term_refs(2);
	term_t a2 = a1 + 1;
    predicate_t p;
	qid_t query;
	char message1[80], message2[80];
	
	message1[79] = 0;
	message2[79] = 0;

	p = PL_predicate("isa", 2, "user");

	query = PL_open_query(NULL, TRUE, p, a1);
	while (PL_next_solution(query)) {
		char *result1, *result2;

		PL_get_atom_chars(a1,&result1);
		PL_get_atom_chars(a2,&result2);
		
        strcpy(message1,result1);

		strcpy(message2,result2);

		MessageBox(NULL, "Step1", message1, MB_OK|MB_TASKMODAL);
	
		
	
		strcat(message1, " ");
		strcat(message1,message2);
	    
		MessageBox(NULL, "Step2", message2, MB_OK|MB_TASKMODAL);
	}
	PL_close_query(query);
}


 
void
anchestor(const char *me, char *result)
{ 
	term_t a1 = PL_new_term_refs(2);
	term_t a2 = a1 + 1;
    predicate_t p;
	qid_t query;
	//char tmp[80];
	//tmp[79] = 0;
	char *tmp;
	p = PL_predicate("isa", 2, "user");

	PL_put_atom_chars(a1, me);
	query = PL_open_query(NULL, TRUE, p, a1);
	PL_next_solution(query);
	PL_get_atom_chars(a2, &tmp);	
	strcpy(result,tmp);
	
	PL_close_query(query);
}

/* ----------------------------------------------------------------------------------------- */
/*                         Generic interface                                                 */
/* ----------------------------------------------------------------------------------------- */

void make_goal(const char *functorname, int arity) {

	current_arguments = PL_new_term_refs(arity);
	current_predicate = PL_predicate(functorname, arity, "user");
}

void put_integer(const int value, const int pos) {
     term_t arg = current_arguments + pos;
	 PL_put_integer(arg,value);
}

void put_float(const double value, const int pos) {
     term_t arg = current_arguments + pos;
	 PL_put_float(arg,value);
}

void put_string(const char *value, const int pos) {
	term_t arg = current_arguments + pos;
	PL_put_string_chars(arg, value);
}

void put_atom(const char *value, const int pos) {
	term_t arg = current_arguments + (pos - 1);
	PL_put_atom_chars(arg, value);
}


int get_integer(const int pos) {
	int tmp,result;
//	char buf[80];

	term_t arg = current_arguments + (pos - 1);
	PL_get_integer(arg, &tmp);
//	sprintf(buf,"integer= %d",tmp);
//  MessageBox(NULL, buf, "integer", MB_OK|MB_TASKMODAL);
	result = tmp;
	return result;
}



/*
NOMANGLE short CCONV get_integer(const int pos) {
	int tmp;
	short result;
	term_t arg = current_arguments + (pos - 1);

	char buf[80];

	PL_get_integer(arg, &tmp);

	sprintf(buf,"int = %d",tmp);
	MessageBox(NULL, buf, "integer", MB_OK|MB_TASKMODAL);
	
	result = tmp;
	return result;
}


*/


/*
void get_atom(char *value, const int pos) {
	char *tmp;

	term_t arg = current_arguments + (pos - 1);
	PL_get_atom_chars(arg, &tmp);
	strcpy(value,tmp);
}
*/


NOMANGLE double CCONV get_float(const int pos) {
	double tmp;
	double result;
	
//	char buf[80];
	term_t arg = current_arguments + (pos - 1);
	PL_get_float(arg, &tmp);
	result = tmp;
//	sprintf(buf,"%f",tmp);
//	MessageBox(NULL, "integer", buf, MB_OK|MB_TASKMODAL);

  return result;
}


NOMANGLE BSTR CCONV get_atom(const int pos) {
	BSTR value;
	char *tmp; 
	int i,len;	
	LPSTR strDst;


	term_t arg = current_arguments + (pos - 1);
	PL_get_atom_chars(arg, &tmp);
    len = strlen(tmp);

	value = SysAllocStringLen(NULL,len);

	strDst = (LPSTR)value;
	for (i = 0 ; i <= len; i++) 
	 *strDst++ = *tmp++;   
	return value;
}

/* Functie werkt, maar ik ben nog aan het debuggen */

NOMANGLE BSTR CCONV get_string(const int pos) {
	BSTR value;
	char *tmp; 
	int i,len, type;	
	LPSTR strDst;

	term_t arg = current_arguments + (pos - 1);
	if (PL_is_string(arg)) {

		PL_get_string(arg, &tmp, &len);
//		sprintf(buf,"string =: %s",tmp);
//		MessageBox(NULL, buf, "string", MB_OK|MB_TASKMODAL);

		value = SysAllocStringLen(NULL,len);

		strDst = (LPSTR)value;
		for (i = 0 ; i <= len; i++) 
		*strDst++ = *tmp++;   
		return value;
	}
	else {
		char *mess;
		type = PL_term_type(arg);
		switch (type) {
		case PL_VARIABLE:
			     strcpy(mess,"var");
				 break;
		case PL_ATOM:
			     strcpy(mess,"atom");
			break;
		case PL_STRING:
				strcpy(mess,"string");
			break;
		case PL_INTEGER:
				strcpy(mess,"int");
			break;
		case PL_FLOAT:
				strcpy(mess,"float");
			break;
		case PL_TERM:
				strcpy(mess,"term");
		default:
				strcpy(mess,"NO TYPE!!!");
		}

		MessageBox(NULL, mess, "string", MB_OK|MB_TASKMODAL);
		return value;
	}

}



void init_query() {
	if (current_query != 0) close_query();
	current_query = PL_open_query(NULL, PL_Q_NORMAL, current_predicate, current_arguments);
}


void close_query() {
	PL_close_query(current_query);
	current_query = 0;
//	current_predicate = 0;
//	current_arguments = 0;
}

int next_solution() {
	int success = PL_next_solution(current_query);
	if (! success) close_query();
	return success;
}

/*

  Dit werkt niet
int one_solution() {
	int success = PL_next_solution(current_query);
	PL_cut_query(current_query);
	return success;
}

  */
/*
void query(char *functor, int arity, char **args)
{
	term_t a1 = PL_new_term_refs(arity);
	int i;
	for (cnt i = 2 ; i =< arity, i++) {
		term_t = 
*/
 /*
 if ( PL_get_atom_chars(to, &a) )
  { MessageBox(NULL, a, "DLL test", MB_OK|MB_TASKMODAL);

*/
/*
void convertstr() {
	BSTR wstr;
	char mystr[80];
	
	strcp(80)
*/
